<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.24 $
 * $Author: tora60 $
 * $Date: 2008/07/14 22:47:31 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

defined('mxMainFileLoaded') or die('access denied');

$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);
$pagetitle = _ENCYCLOPEDIA;

function encysearch($eid)
{
    global $module_name;
    echo "<center><form action=\"modules.php?name=$module_name&amp;file=search\" method=\"post\">"
     . "<input type=\"text\" size=\"20\" name=\"query\" />&nbsp;&nbsp;"
     . "<input type=\"hidden\" name=\"eid\" value=\"$eid\" />"
     . "<input type=\"submit\" value=\"" . _SEARCH . "\" />"
     . "</form>"
     . "</center>";
}

function alpha($eid)
{
    global $module_name, $prefix;
    echo "<center>" . _ENCYSELECTLETTER . "</center><br /><br />";
    // $alphabet = array ("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z");
    $alphabet = array ("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M",
        "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "", "", "", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0");
    $num = count($alphabet) - 1;
    $half = round($num / 2);

    echo "<center>[ ";
    $result = sql_query("SELECT DISTINCT UPPER(LEFT(title, 1)) from " . $prefix . "_encyclopedia_text WHERE eid=" . intval($eid));
    while ($row = sql_fetch_row($result)) {
        $titles[$row[0]] = $row[0];
    }

    $counter = 0;
    foreach ($alphabet as $ltr) {
        if (isset($titles[$ltr])) {
            echo "<a href=\"modules.php?name=$module_name&amp;op=terms&amp;eid=$eid&amp;ltr=$ltr\">$ltr</a>";
        } else {
            echo $ltr;
        }
        if ($counter == $half) {
            echo " ]\n<br />\n[ ";
        } elseif ($counter != $num) {
            echo "&nbsp;|&nbsp;";
        }
        $counter++;
    }
    echo " ]</center><br /><br />\n\n\n";
    encysearch($eid);
    echo "<center>" . _GOBACK . "</center>";
}

function CrossLinker(&$c, $eid, $t)
{
    global $module_name, $prefix, $textcolor1;

    $y = "";

    $result = sql_query("select tid, title from " . $prefix . "_encyclopedia_text where eid=" . intval($eid) . " order by length('title') desc, 'title' asc");
    $num = sql_num_rows($result);

    for ($i = 0; $i < $num; $i++) {
        $ntit = mysql_result($result, $i, "title");
        $ntid = mysql_result($result, $i, "tid");

        $x = "<a href=\"modules.php?name=" . $module_name . "&amp;op=content&amp;tid=" . $ntid . "\">" . $ntit . "</a>";
        if ($c && $ntit && strpos($c, $ntit) > 0) {
            if ($ntit <> $t) {
                $y = $y . '[ ' . $x . ' ] ';
            }
        }
    }
    if ($y > "") {
        $c = $c . "<br /><br /><p style=\"border-width:thin; border-color:#CEE6FF; border-style:dashed; padding:4px;\" align=\"middle\">" . _ENCYCROSSLINKS . ":<br />" . $y . "</p>";
    }
    return $c;
}

function list_content()
{
    global $module_name, $prefix, $pagetitle;
    $eid = (empty($_REQUEST['eid'])) ? 0 : intval($_REQUEST['eid']);
    $result = sql_query("select title, description from " . $prefix . "_encyclopedia where eid=" . intval($eid));
    list($title, $description) = sql_fetch_row($result);
    $pagetitle = _ENCYCLOPEDIA . ', ' . $title;
    include("header.php");
    title(_ENCYCLOPEDIA);
    OpenTable();
    echo "<center><b>$title</b></center><br />"
     . "<p align=\"justify\">$description</p>";
    CloseTable();
    echo '<br />';
    OpenTable();
    alpha($eid);
    CloseTable();
    echo '<br />';
    OpenTable();
    echo "<center><font class=\"tiny\">" . _COPYRIGHT . "</font></center>";
    CloseTable();
    include("footer.php");
}

/************************************ NEUE FUNKTION UM ALLE EINTRGE EINER ENCY ANZUZEIGEN ************************************/
function list_content_all()
{
    global $module_name, $prefix, $pagetitle;
    $eid = (empty($_REQUEST['eid'])) ? 0 : intval($_REQUEST['eid']);
    $result = sql_query("select tid, eid, title from " . $prefix . "_encyclopedia_text where eid=" . intval($eid) . " ORDER BY title ASC");

        $pagetitle = _ENCYCLOPEDIA . ', ' . $title;
    include("header.php");
    title(_ENCYCLOPEDIA);
    OpenTable();

// wie viele Eintrge gibt es ?
$countrows = mysql_num_rows($result) ;

// wenns mehr als 0 sind, dann mach doch bitte folgendes ;-)
if($countrows > 0) {

// wie viele Spalten sollen es sein
$cols = 4;

// Zeilenanzahl ausrechnen
$rows = ceil($countrows / $cols);

// Ausgabe Tabelle
echo "<table border=\"1\" align=\"center\" class=\"list\" cellpadding=\"10\" cellspacing=\"0\" width=\"100%\" >";
for($i = 1; $i <= $rows; $i++) {

   echo "<tr>";

   for($j = 1; $j <= $cols; $j++) {

           $list = mysql_fetch_assoc($result);
          // solange was in der DB steht, gib folgendes aus
            if(!empty($list['title'])) {

                 // Link zusammensetzen
         echo "<td align=\"center\"><a href=\"/modules.php?name=Encyclopedia&amp;op=content&amp;tid=$list[tid]\">$list[title]</a></td>";

      } else {
                 // falls nix mehr von der kommt, Zellen mit Leerzeichen fllen ;-)
         echo "<td>&nbsp;</td>";
      }
   }
   echo "</tr>";
}
echo "</table>";

}

    CloseTable();
    echo '<br />';
    OpenTable();
    alpha($eid);
    CloseTable();
    echo '<br />';
    OpenTable();
    echo "<center><font class=\"tiny\">" . _COPYRIGHT . "</font></center>";
    CloseTable();
    include("footer.php");
}

/************************************ ENDE NEUE FUNKTION ************************************/

function terms()
{
    global $module_name, $prefix, $pagetitle;
    $eid = (empty($_REQUEST['eid'])) ? 0 : intval($_REQUEST['eid']);
    $ltr = (empty($_REQUEST['ltr'])) ? 'A' : strtoupper(substr($_REQUEST['ltr'], 0, 1));
    $count = -1;
    $items = 2; // Anzahl gewnschter Spalten
    $result = sql_query("select active, title from " . $prefix . "_encyclopedia where eid=" . intval($eid));
    list($active, $title) = sql_fetch_row($result);
    $pagetitle = _ENCYCLOPEDIA . ', ' . $title;
    include("header.php");
    title(_ENCYCLOPEDIA);
    OpenTable();
    if (($active == 1) OR (MX_IS_ADMIN)) {
        if (($active != 1) AND (MX_IS_ADMIN)) {
            echo "<center>" . _YOURADMINENCY . "</center><br /><br />";
        }
        echo "<center>" . _SECTIONSTERMSINENCY . " &quot;<strong>{$title}</strong>&quot;:</center><br /><br />"
         . "<table border=\"0\" align=\"center\">";
        $result = sql_query("select tid, title from " . $prefix . "_encyclopedia_text WHERE UPPER(title) LIKE '" . mxAddSlashesForSQL($ltr) . "%' AND eid=" . intval($eid) . " ORDER BY title");
        if (sql_num_rows($result) == 0) {
            echo "<center><i>" . _NOCONTENTFORLETTER . " $ltr.</i></center>";
        } while (list($tid, $title) = sql_fetch_row($result)) {
            if ($count == -1) {
                $count = 0;
                echo "<tr>";
            }
            $count = $count + 1;
            echo "<td>&nbsp;&middot;&nbsp;<a href=\"modules.php?name=$module_name&amp;op=content&amp;tid=$tid\"><font class=\"option\">$title</font></a></td>";
            if ($count == $items) {
                $count = 0;
                echo "</tr><tr>";
            }
        }
        $fill = $items - $count;
        if ($fill != 0) {
            echo "<td colspan=\"{$fill}\">&nbsp;</td>";
        }
        if ($count == 0) {
            echo "</tr>";
        }
        echo "</tr></table><br /><br />";
        alpha($eid);
    } else {
        echo "<center>" . _ENCYNOTACTIVE . '<br /><br />' . _GOBACK . "</center>";
    }
    CloseTable();
    include("footer.php");
}

function content()
{
    global $prefix, $sitename, $module_name, $pagetitle;
    $tid = (empty($_REQUEST['tid'])) ? 0 : intval($_REQUEST['tid']);
    $ltr = (empty($_REQUEST['ltr'])) ? '' : substr($_REQUEST['ltr'], 0, 1);
    $page = (empty($_REQUEST['page'])) ? 1 : intval($_REQUEST['page']);
    $query = (empty($_REQUEST['query'])) ? '' : strip_tags($_REQUEST['query']);

    $result = sql_query("SELECT * from " . $prefix . "_encyclopedia_text where tid='$tid'");
    $ency = sql_fetch_array($result);
    $result = sql_query("select active, title from " . $prefix . "_encyclopedia where eid=" . intval($ency['eid']));
    list($active, $enc_title) = sql_fetch_row($result);

    $pagetitle = _ENCYCLOPEDIA . ', ' . $enc_title;
    include("header.php");
    title(_ENCYCLOPEDIA);
    OpenTable();
    if (($active == 1) OR ($active == 0 AND (MX_IS_ADMIN))) {
        sql_query("update " . $prefix . "_encyclopedia_text set counter=counter+1 where tid='" . intval($tid) . "'");
        if (MX_IS_ADMIN) {
            echo '<a href="admin.php?op=encyclopedia_text_edit&amp;tid=' . $tid . '">' . mxCreateImage('images/edit.gif', _EDIT) . '</a>&nbsp;<a href="admin.php?op=encyclopedia_text_delete&amp;tid=' . $tid . '&amp;ok=0">' . mxCreateImage('images/delete.gif', _DELETE) . '</a>&nbsp;';
        }
        echo "<font class=\"title\">$ency[title]</font><br /><br /><br />";
        if ($ency['autolink']) {
            // Wenn gesetzt, automatisches Verlinken - Ver.: 0.1.7
            CrossLinker($ency['text'], $ency['eid'], $ency['title']);
        }
        $contentpages = explode("<!--pagebreak-->", $ency["text"]);
        $pageno = count($contentpages);
        if ($page == 0 || $page < 1)
            $page = 1;
        if ($page > $pageno)
            $page = $pageno;
        $arrayelement = intval($page);
        $arrayelement --;
        if ($pageno > 1) {
            echo _PAGE . ": $page/$pageno<br />";
        }
        if (!empty($query)) {
            $contentpages[$arrayelement] = str_replace($query, "<b>" . mxPrepareToDisplay($query) . "</b>", $contentpages[$arrayelement]);
            $fromsearch = "&amp;query=" . urlencode($query);
        } else {
            $fromsearch = "";
        }
        echo "<div align=\"justify\">" . $contentpages[$arrayelement] . "</div>";
        $next_page = '';
        $previous_page = '';
        if ($page >= $pageno) {
            $next_page = "";
        } else {
            $next_pagenumber = $page + 1;
            if ($page != 1) {
                $next_page .= "- ";
            }
            $next_page .= '<a href="modules.php?name=' . $module_name . '&amp;op=content&amp;tid=' . $tid . '&amp;page=' . $next_pagenumber . $fromsearch . '">' . _NEXT . ' (' . $next_pagenumber . '/' . $pageno . ')</a> <a href="modules.php?name=' . $module_name . '&amp;op=content&amp;tid=' . $tid . '&amp;page=' . $next_pagenumber . '">' . mxCreateImage('images/right.gif', _NEXT) . '</a>';
        }
        if ($page <= 1) {
            $previous_page = "";
        } else {
            $previous_pagenumber = $page - 1;
            $previous_page = '<a href="modules.php?name=' . $module_name . '&amp;op=content&amp;tid=' . $tid . '&amp;page=' . $previous_pagenumber . $fromsearch . '">' . mxCreateImage('images/left.gif', _PREVIOUS) . '</a> <a href="modules.php?name=' . $module_name . '&amp;op=content&amp;tid=' . $tid . '&amp;page=' . $previous_pagenumber . $fromsearch . '">' . _PREVIOUS . ' (' . $previous_pagenumber . '/' . $pageno . ')</a>';
        }
        echo "<br /><br /><br /><center>$previous_page $next_page<br /><br />" . _GOBACK . "</center><br />";

    } else {
        echo "" . _SECTIONSISNA . "";
    }
    CloseTable();
    include("footer.php");
}

function list_themes()
{
    global $prefix, $sitename, $multilingual, $module_name;
    include("header.php");
    title(_ENCYCLOPEDIA);
    OpenTable();

    $result = sql_query("SELECT eid, title, description, elanguage from " . $prefix . "_encyclopedia WHERE active=1");
    if (sql_num_rows($result) >= 1) {
        echo '<div style="padding-left: 30px;">';
        while (list($eid, $title, $description, $elanguage) = sql_fetch_row($result)) {
            if ($multilingual == 1) {
                $the_lang = mxCreateImage('images/language/flag-' . $elanguage . '.png', '', 0, 'hspace="3"');
            } else {
                $the_lang = "";
            }
            if (!empty($subtitle)) {
                $subtitle = "<br />($description)<br /><br />";
            } else {
                $subtitle = "";
            }
            if (MX_IS_ADMIN) {
                echo "<strong><big>&middot;</big></strong> $the_lang <a href=\"modules.php?name=$module_name&amp;op=list_content&amp;eid=$eid\">$title</a><br />$description<br />[&nbsp;<a href=\"admin.php?op=encyclopedia_edit&amp;eid=$eid\">" . _EDIT . "</a> | <a href=\"admin.php?op=encyclopedia_change_status&amp;eid=$eid&amp;active=1\">" . _DEACTIVATE . "</a> | <a href=\"admin.php?op=encyclopedia_delete&amp;eid=$eid\">" . _DELETE . "</a>&nbsp;]<br /><br />";
            } else {
                echo "<strong><big>&middot;</big></strong> $the_lang <a href=\"modules.php?name=$module_name&amp;op=list_content&amp;eid=$eid\">$title</a><br /> $description<br /><br />";
            }
        }
        echo '</div>';
    }
    if (MX_IS_ADMIN) {
        $result = sql_query("SELECT eid, title, description, elanguage from " . $prefix . "_encyclopedia WHERE active='0'");
        echo "<br /><br /><center><b>" . _YOURADMININACTIVELIST . "</b></center><br /><br />";
        if (sql_num_rows($result) >= 1) {
            echo '<div style="padding-left: 30px;">';
            while (list($eid, $title, $description, $elanguage) = sql_fetch_row($result)) {
                if ($multilingual == 1) {
                    $the_lang = mxCreateImage('images/language/flag-' . $elanguage . '.png', '', 0, 'hspace="3"');
                } else {
                    $the_lang = "";
                }
                if (!empty($subtitle)) {
                    $subtitle = " ($subtitle) ";
                } else {
                    $subtitle = " ";
                }
                echo "<strong><big>&middot;</big></strong> $the_lang <a href=\"modules.php?name=" . $module_name . "&amp;op=content&amp;eid=$eid\">$title</a><br />$description<br />[&nbsp;<a href=\"admin.php?op=encyclopedia_edit&amp;eid=$eid\">" . _EDIT . "</a> | <a href=\"admin.php?op=encyclopedia_change_status&amp;eid=$eid&amp;active=0\">" . _ACTIVATE . "</a> | <a href=\"admin.php?op=encyclopedia_delete&amp;eid=$eid\">" . _DELETE . "</a>&nbsp;]<br /><br />";
            }
            echo '</div>';
        }
    }
    CloseTable();
    include("footer.php");
}

$op = (empty($_REQUEST['op'])) ? '' : $_REQUEST['op'];
switch ($op) {
    case "content":
        content();
        break;

    case "list_content":
        list_content();
        break;

    case "terms":
        terms();
        break;

    case "all":
        list_content_all();
        break;

    default:
        list_themes();
        break;
}

?>